#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

int left_deepest(int start, float *set);
int right_deepest(int start, float *set);
void get_positive_float(float *val);
void get_positive_int(int *val);
void left_turn(int deepest, float interval, float *depth, float *width, float *angle);
void right_turn(int deepest, int ending, float interval, float *depth, float *width, float *angle);

int main()
{
	float interval, max_depth = 0, start, finish;
	const float tangens = tan(3.14*7/180);
	int n, i, deepest;

	printf("Enter the interval between points: ");
	get_positive_float(&interval);
	if (interval == 0) {
		printf("Interval must be positive.\n");
		exit(3);
	}

	printf("Enter the number of points: ");
	get_positive_int(&n);

	float depth[n];
	float width[n];
	float angle[n];

	for (i = 0; i < n; i++) {
		printf("Enter the depth in point %i: ", i+1);
		get_positive_float(&depth[i]);

		depth[i] += 1.5;
		width[i] = interval;

		if (depth[i] >= max_depth) {
			deepest = i;
			max_depth = depth[i];
		}
	}

	left_turn(deepest, interval, depth, width, angle);
	right_turn(deepest, n, interval, depth, width, angle);

	start = depth[0]/tangens;
	finish = depth[n]/tangens;

	printf("Entrance point is in %f to Point 1.\n\t angle:\t7 degrees\n", start);

	for (i = 0; i < deepest; i++) {
		printf("Point %i:\n\tdepth:\t%f\n\t", i+1, depth[i]);
		printf("angle:\t%f degrees, machine turned down\n", angle[i]);
	}

	printf("Point %i:\n\tdepth:\t%f, the deepest point\n", deepest,depth[deepest]);
	printf("\tangle:\t%f degrees, machine turned up\n", angle[deepest]);

	for (i = deepest+1; i < n; i++) {
		printf("Point %i:\n\tdepth:\t%f\n\t", i+1, depth[i]);
		printf("angle:\t%f degrees, machine turned up\n", angle[i]);
	}

	printf("Leaving point is in %f from Point %i.\n\t angle:\t7 degrees\n", finish,n);
	printf("\nEnter 'E' or 'e' for exit\n\n");

	while (tolower(getchar())!= 'e') {}
	return 0;
}

void get_positive_float(float *val)
{
	int res;

	res = scanf( "%f", val);
	if (res < 1) {
		printf("You entered some trash\n");
		exit(1);
	}

	if (*val < 0) {
		printf("You entered negative number\n");
		exit(2);
	}
}

void get_positive_int(int *val)
{
	int res;

	res = scanf( "%i", val);
	if (res < 1) {
		printf("You entered some trash\n");
		exit(1);
	}

	if (*val <= 0) {
		printf("You entered non-positive number\n");
		exit(2);
	}
}

int left_deepest(int start, float *set)
{
	int max, i;
	float max_val = 0;

	for (i = start-1; i >= 0; i--) {
		if (set[i] > max_val) {
			max = i;
			max_val = set[i];
		}
	}

	return max;
}

int right_deepest(int start, float *set)
{
	int max, i;
	float max_val = 0;

	for (i = start+1; set[i]; i++) {
		if (set[i] > max_val) {
			max = i;
			max_val = set[i];
		}
	}
	
	return max;
}

void left_turn(int deepest, float interval, float *depth, float *width, float *angle)
{
	const float dh0 = tan(3.14*7/180) * interval;
	float dh;
	int temp, i, warps;

	do {
		temp = left_deepest(deepest, depth);
		dh = depth[deepest] - depth[temp];
		warps = deepest - temp;;

		if (dh < dh0*warps) {
			for (i = (deepest-1); i >= temp; i--) {
				angle[i] = 180*atan2(dh, interval * warps)/3.14;
				depth[i] = depth[deepest] - dh*(deepest - i)/warps;
			}
		} else {
			for (i = (deepest-1); i >= temp; i--) {
				angle[i] = 7;
				depth[i] = depth[deepest] - dh0*(deepest - i);
			}
		}

		deepest = temp;
	} while (temp > 0);
}

void right_turn(int deepest, int ending, float interval, float *depth, float *width, float *angle)
{
	const float dh0 = tan(3.14*7/180) * interval;
	float dh;
	int temp, i, warps;

	do {
		temp = right_deepest(deepest, depth);
		dh = depth[deepest] - depth[temp];
		warps = temp - deepest - 1;

		if (dh < dh0*warps) {
			for (i = deepest; i <= temp; i++) {
				angle[i] = 180*atan2(dh, interval * warps)/3.14;
				depth[i] = depth[deepest] - dh*(i - deepest)/warps;
			}
		} else {
			for (i = deepest; i <= temp; i++) {
				angle[i] = 7;
				depth[i] = depth[deepest] - dh0*(i - deepest);
			}
		}

		deepest = temp;
	} while (temp < ending);
}
